--[[===========================================================
    WINDY LOADS MOD
    =============================================================
	2021-12: originally implemented for FS22 by Sushifresser
]]

WindyLoadsBlowEvent = {};
local WindyLoadsBlowEvent_mt = Class(WindyLoadsBlowEvent, Event);
InitEventClass(WindyLoadsBlowEvent, "WindyLoadsBlowEvent");

function WindyLoadsBlowEvent.emptyNew()
	local self =  Event.new(WindyLoadsBlowEvent_mt);
	return self;
end

function WindyLoadsBlowEvent.new(vehicle, fillUnitIndex, newVol)
	local self = WindyLoadsBlowEvent.emptyNew();
	self.vehicle = vehicle;
	self.fillUnitIndex = fillUnitIndex;
	self.newVol = newVol;
	return self;
end

function WindyLoadsBlowEvent:readStream(streamId, connection)
	self.vehicle = NetworkUtil.readNodeObject(streamId);
	self.fillUnitIndex = streamReadUIntN(streamId, FillTypeManager.SEND_NUM_BITS);
	self.newVol = streamReadFloat32(streamId);
	self:run(connection);
end

function WindyLoadsBlowEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.vehicle);
	streamWriteUIntN(streamId, self.fillUnitIndex, FillTypeManager.SEND_NUM_BITS);
	streamWriteFloat32(streamId, self.newVol);
	
end

function WindyLoadsBlowEvent:run(connection)
	if not connection:getIsServer() then
		--print("[WindyLoadsBlowEvent]: server")
		self.vehicle:blowFromFillUnit(self.fillUnitIndex, self.newVol, true);
		g_server:broadcastEvent(self, false, connection, self.vehicle);
	else
		--print("[WindyLoadsBlowEvent]: client")
		self.vehicle:blowFromFillUnit(self.fillUnitIndex, self.newVol, true);
	end
end

function WindyLoadsBlowEvent.sendEvent(vehicle, fillUnitIndex, newVol, noEventSend)
	if noEventSend == nil or not noEventSend then
		--print("[WindyLoadsBlowEvent]: sending WindyLoadsBlowEvent");
		if g_server ~= nil then
			g_server:broadcastEvent(WindyLoadsBlowEvent.new(vehicle, fillUnitIndex, newVol), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(WindyLoadsBlowEvent.new(vehicle, fillUnitIndex, newVol));
		end
	end


end